import { ConcreteException } from '../base.js';
import { ErrorType } from '../types/index.js';
import { mapMetamaskMessage } from '../utils/maps.js';
const removeMetamaskFromErrorString = (message) => message
    .replaceAll('Rainbow', '')
    .replaceAll('RainBow', '')
    .replaceAll('Rainbow:', '');
export class RainbowWalletException extends ConcreteException {
    static errorClass = 'RainbowWalletException';
    constructor(error, context) {
        super(error, context);
        this.type = ErrorType.WalletError;
    }
    parse() {
        const { message } = this;
        this.setMessage(mapMetamaskMessage(removeMetamaskFromErrorString(message)));
        this.setName(RainbowWalletException.errorClass);
    }
}
